/*
    (C) 1999 AROS - The Amiga Research OS
    $Id: reqtools_intern.h,v 1.1.1.1 2005/03/15 15:56:47 laire Exp $

    Desc:
    Lang: English
*/

/****************************************************************************************/

#ifndef REQTOOLS_INTERN_H
#define REQTOOLS_INTERN_H

/****************************************************************************************/

#define USE_MEMPOOL	1

/****************************************************************************************/

#include <exec/execbase.h>
#include <dos/dos.h>
#include <libraries/reqtools.h>
#include <libraries/locale.h>
#include <intuition/intuition.h>
#include <intuition/classes.h>

#include "general.h"

#if USE_MEMPOOL
#include "mempool.h"
#endif /* USE_MEMPOOL */


#ifdef __MORPHOS__
void memclr(APTR, ULONG);
#define bzero(a,b) memclr(a,b)
#else /* __MORPHOS__ */
#define memclr(a,b) bzero(a,b)
#endif /* __MORPHOS__ */

/****************************************************************************************/

struct IntReqToolsBase
{
    struct ReqToolsBase	rt;

    struct ExecBase 	*rt_SysBase;

#if 1
    struct Library 	*rt_LocaleBase;
    struct Library 	*rt_LayersBase;

#ifdef __MORPHOS__
    struct Library 	*rt_ConsoleDevice;
#else /* __MORPHOS__ */
    struct Device 	*rt_ConsoleDevice;
#endif /* __MORPHOS__ */
    struct IOStdReq	rt_iorequest;
    Class		*rt_ButtonImgClass;
#endif
    struct Library	*rt_WorkbenchBase;
    struct Hook		rt_stredithook;

    struct IORequest 	rt_cdevio;   /* For communication with console.device */

#if USE_MEMPOOL
    APTR		rt_Pool;
#endif /* USE_MEMPOOL */
};

/****************************************************************************************/

#if USE_MEMPOOL

#define rtAllocMem(a,b)		poolAllocMem(IntReqToolsBase->rt_Pool,a,b)
#define rtFreeMem(a,b)		poolFreeMem(IntReqToolsBase->rt_Pool,a,b)
#define rtAllocVec(a,b)		poolAllocVec(IntReqToolsBase->rt_Pool,a,b)
#define rtFreeVec(a)		poolFreeVec(IntReqToolsBase->rt_Pool,a)

//#define rtAllocVecPooled(a,b)	poolAllocVec(IntReqToolsBase->rt_Pool,b)
//#define rtFreeVecPooled(a,b)	poolFreeVec(IntReqToolsBase->rt_Pool,b)

#else /* USE_MEMPOOL */

#define rtAllocMem(a,b)		AllocMem(a,b)
#define rtFreeMem(a,b)		FreeMem(a,b)
#define rtAllocVec(a,b)		AllocVec(a,b)
#define rtFree(a)		FreeVec(a)

#endif /* USE_MEMPOOL */

#define rtAllocVecPooled(a,b)	AllocVecPooled(a,b)
#define rtFreeVecPooled(a,b)	FreeVecPooled(a,b)

/****************************************************************************************/

#ifdef _AROS

/* filereqalloc.c */

struct RealFileRequester;

APTR AllocRequestA (ULONG type, struct TagItem *taglist,
	            struct IntReqToolsBase *);
void FreeRequest (APTR,
	          struct IntReqToolsBase *);
void FreeReqBuffer (APTR,
	            struct IntReqToolsBase *);
LONG ChangeReqAttrA (APTR, struct TagItem *,
	             struct IntReqToolsBase *);
APTR FileRequestA(struct RealFileRequester *,char *,char *,struct TagItem *,
	          struct IntReqToolsBase *);
void FreeFileList (struct rtFileList *,
	           struct IntReqToolsBase *);

/* general.c */

int GetVScreenSize (struct Screen *scr, int *width, int *height,
	            struct IntReqToolsBase *IntReqToolsBase);

/* req.c */

ULONG GetString (UBYTE *stringbuff, LONG maxlen, const char *title,
		 ULONG checksum, ULONG *value, LONG mode,
	         struct rtReqInfo *reqinfo, struct TagItem *taglist,
	         struct IntReqToolsBase *IntReqToolsBase);

/* palettereq.c */

LONG PaletteRequestA (char *title, struct rtReqInfo *reqinfo, struct TagItem *taglist,
	              struct IntReqToolsBase *IntReqToolsBase);

#endif

/****************************************************************************************/

#ifdef __MORPHOS__

#define rtLockPrefs() \
	LP0(168, struct ReqToolsPrefs *, rtLockPrefs, \
		, REQTOOLS_BASE_NAME, 0, 0, 0, 0, 0, 0)
#define rtUnlockPrefs() \
	LP0NR(174, rtUnlockPrefs, \
		, REQTOOLS_BASE_NAME, 0, 0, 0, 0, 0, 0)

#else /* __MORPHOS__ */

#ifndef _AROS

#ifdef __SASC
#pragma libcall ReqToolsBase rtLockPrefs a8 00
#pragma libcall ReqToolsBase rtUnlockPrefs ae 00
#else
#warning You might have to fix rtLockPrefs/rtUnlockPrefs for your compiler
#endif

#endif

#endif /* __MORPHOS__ */

/****************************************************************************************/

/* Fix name clashes */
typedef  struct IntuitionBase  IntuiBase;

#define GPB(x) 		((struct IntReqToolsBase *)x)

#ifdef _AROS
#define expunge() \
AROS_LC0(BPTR, expunge, struct IntReqToolsBase *, RTBase, 3, ReqTools)
#endif

/****************************************************************************************/

/* boopsi.c */
extern ULONG ASM myTextLength (ASM_REGPARAM(a1, char *,),
    	    	    	       ASM_REGPARAM(a0, struct TextAttr *,),
			       ASM_REGPARAM(a3, UBYTE *,),
			       ASM_REGPARAM(a2, struct Image *,),
			       ASM_REGPARAM(d7, ULONG,),
			       ASM_REGPARAM(a6, struct IntReqToolsBase *,));

#endif /* REQTOOLS_INTERN_H */
